/* A Bison parser, made by GNU Bison 2.5.  */

/* Skeleton implementation for Bison LALR(1) parsers in C++
   
      Copyright (C) 2002-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */


/* First part of user declarations.  */


/* Line 293 of lalr1.cc  */
#line 39 "parser.cpp"


#include "parser.hpp"

/* User implementation prologue.  */


/* Line 299 of lalr1.cc  */
#line 48 "parser.cpp"
/* Unqualified %code blocks.  */

/* Line 300 of lalr1.cc  */
#line 43 "parser.y"

#include "driver.hpp"



/* Line 300 of lalr1.cc  */
#line 59 "parser.cpp"

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                               \
 do                                                                    \
   if (N)                                                              \
     {                                                                 \
       (Current).begin = YYRHSLOC (Rhs, 1).begin;                      \
       (Current).end   = YYRHSLOC (Rhs, N).end;                        \
     }                                                                 \
   else                                                                \
     {                                                                 \
       (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;        \
     }                                                                 \
 while (false)
#endif

/* Suppress unused-variable warnings by "using" E.  */
#define YYUSE(e) ((void) (e))

/* Enable debugging if requested.  */
#if YYDEBUG

/* A pseudo ostream that takes yydebug_ into account.  */
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)	\
do {							\
  if (yydebug_)						\
    {							\
      *yycdebug_ << Title << ' ';			\
      yy_symbol_print_ ((Type), (Value), (Location));	\
      *yycdebug_ << std::endl;				\
    }							\
} while (false)

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug_)				\
    yy_reduce_print_ (Rule);		\
} while (false)

# define YY_STACK_PRINT()		\
do {					\
  if (yydebug_)				\
    yystack_print_ ();			\
} while (false)

#else /* !YYDEBUG */

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_REDUCE_PRINT(Rule)
# define YY_STACK_PRINT()

#endif /* !YYDEBUG */

#define yyerrok		(yyerrstatus_ = 0)
#define yyclearin	(yychar = yyempty_)

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)


namespace yy {

/* Line 382 of lalr1.cc  */
#line 145 "parser.cpp"

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              /* Fall through.  */
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  Parser::Parser (Driver& driver_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver (driver_yyarg)
  {
  }

  Parser::~Parser ()
  {
  }

#if YYDEBUG
  /*--------------------------------.
  | Print this symbol on YYOUTPUT.  |
  `--------------------------------*/

  inline void
  Parser::yy_symbol_value_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yyvaluep);
    switch (yytype)
      {
         default:
	  break;
      }
  }


  void
  Parser::yy_symbol_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    *yycdebug_ << (yytype < yyntokens_ ? "token" : "nterm")
	       << ' ' << yytname_[yytype] << " ("
	       << *yylocationp << ": ";
    yy_symbol_value_print_ (yytype, yyvaluep, yylocationp);
    *yycdebug_ << ')';
  }
#endif

  void
  Parser::yydestruct_ (const char* yymsg,
			   int yytype, semantic_type* yyvaluep, location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yymsg);
    YYUSE (yyvaluep);

    YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

    switch (yytype)
      {
  
	default:
	  break;
      }
  }

  void
  Parser::yypop_ (unsigned int n)
  {
    yystate_stack_.pop (n);
    yysemantic_stack_.pop (n);
    yylocation_stack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif

  inline bool
  Parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  Parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::parse ()
  {
    /// Lookahead and lookahead in internal form.
    int yychar = yyempty_;
    int yytoken = 0;

    /* State.  */
    int yyn;
    int yylen = 0;
    int yystate = 0;

    /* Error handling.  */
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// Semantic value of the lookahead.
    semantic_type yylval;
    /// Location of the lookahead.
    location_type yylloc;
    /// The locations where the error started and ended.
    location_type yyerror_range[3];

    /// $$.
    semantic_type yyval;
    /// @$.
    location_type yyloc;

    int yyresult;

    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stacks.  The initial state will be pushed in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystate_stack_ = state_stack_type (0);
    yysemantic_stack_ = semantic_stack_type (0);
    yylocation_stack_ = location_stack_type (0);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* New state.  */
  yynewstate:
    yystate_stack_.push (yystate);
    YYCDEBUG << "Entering state " << yystate << std::endl;

    /* Accept?  */
    if (yystate == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    /* Backup.  */
  yybackup:

    /* Try to take a decision without lookahead.  */
    yyn = yypact_[yystate];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    /* Read a lookahead token.  */
    if (yychar == yyempty_)
      {
	YYCDEBUG << "Reading a token: ";
	yychar = yylex (&yylval, driver);
      }


    /* Convert token to internal form.  */
    if (yychar <= yyeof_)
      {
	yychar = yytoken = yyeof_;
	YYCDEBUG << "Now at end of input." << std::endl;
      }
    else
      {
	yytoken = yytranslate_ (yychar);
	YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
      }

    /* If the proper action on seeing token YYTOKEN is to reduce or to
       detect an error, take that action.  */
    yyn += yytoken;
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yytoken)
      goto yydefault;

    /* Reduce or error.  */
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
	if (yy_table_value_is_error_ (yyn))
	  goto yyerrlab;
	yyn = -yyn;
	goto yyreduce;
      }

    /* Shift the lookahead token.  */
    YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

    /* Discard the token being shifted.  */
    yychar = yyempty_;

    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* Count tokens shifted since error; after three, turn off error
       status.  */
    if (yyerrstatus_)
      --yyerrstatus_;

    yystate = yyn;
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystate];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    /* If YYLEN is nonzero, implement the default value of the action:
       `$$ = $1'.  Otherwise, use the top of the stack.

       Otherwise, the following line sets YYVAL to garbage.
       This behavior is undocumented and Bison
       users should not rely upon it.  */
    if (yylen)
      yyval = yysemantic_stack_[yylen - 1];
    else
      yyval = yysemantic_stack_[0];

    {
      slice<location_type, location_stack_type> slice (yylocation_stack_, yylen);
      YYLLOC_DEFAULT (yyloc, slice, yylen);
    }
    YY_REDUCE_PRINT (yyn);
    switch (yyn)
      {
	  case 2:

/* Line 690 of lalr1.cc  */
#line 121 "parser.y"
    { (yyval.unit) = (yysemantic_stack_[(1) - (1)].unit); driver.result = (yyval.unit); driver.result->codegen(); }
    break;

  case 3:

/* Line 690 of lalr1.cc  */
#line 125 "parser.y"
    { (yyval.unit) = new UnitASTNode(); }
    break;

  case 4:

/* Line 690 of lalr1.cc  */
#line 126 "parser.y"
    { (yyval.unit) = (yysemantic_stack_[(2) - (1)].unit); (yyval.unit)->append((yysemantic_stack_[(2) - (2)].classDef)); }
    break;

  case 5:

/* Line 690 of lalr1.cc  */
#line 127 "parser.y"
    { (yyval.unit) = (yysemantic_stack_[(2) - (1)].unit); (yyval.unit)->append((yysemantic_stack_[(2) - (2)].func)); }
    break;

  case 6:

/* Line 690 of lalr1.cc  */
#line 132 "parser.y"
    { (yyval.classDef) = new ClassDefASTNode(*(yysemantic_stack_[(6) - (2)].sval), (yysemantic_stack_[(6) - (3)].strs), (yysemantic_stack_[(6) - (5)].classBody)); }
    break;

  case 7:

/* Line 690 of lalr1.cc  */
#line 136 "parser.y"
    { (yyval.strs) = new std::vector<std::string>(); }
    break;

  case 8:

/* Line 690 of lalr1.cc  */
#line 137 "parser.y"
    { (yyval.strs) = (yysemantic_stack_[(2) - (2)].strs); }
    break;

  case 9:

/* Line 690 of lalr1.cc  */
#line 142 "parser.y"
    { (yyval.strs) = new std::vector<std::string>(); (yyval.strs)->push_back(*(yysemantic_stack_[(1) - (1)].sval));}
    break;

  case 10:

/* Line 690 of lalr1.cc  */
#line 144 "parser.y"
    { (yyval.strs) = (yysemantic_stack_[(3) - (1)].strs); (yyval.strs)->push_back(*(yysemantic_stack_[(3) - (3)].sval)); }
    break;

  case 11:

/* Line 690 of lalr1.cc  */
#line 149 "parser.y"
    { (yyval.classBody) = new ClassBodyASTNode(); }
    break;

  case 12:

/* Line 690 of lalr1.cc  */
#line 151 "parser.y"
    { (yyval.classBody) = (yysemantic_stack_[(3) - (1)].classBody); (yyval.classBody)->addField((yysemantic_stack_[(3) - (2)].decl)); }
    break;

  case 13:

/* Line 690 of lalr1.cc  */
#line 153 "parser.y"
    { (yyval.classBody) = (yysemantic_stack_[(2) - (1)].classBody); (yyval.classBody)->setConstructor((yysemantic_stack_[(2) - (2)].constrDef)); }
    break;

  case 14:

/* Line 690 of lalr1.cc  */
#line 155 "parser.y"
    { (yyval.classBody) = (yysemantic_stack_[(2) - (1)].classBody); (yyval.classBody)->addMethod((yysemantic_stack_[(2) - (2)].func)); }
    break;

  case 15:

/* Line 690 of lalr1.cc  */
#line 157 "parser.y"
    { (yyval.classBody) = (yysemantic_stack_[(3) - (1)].classBody); (yyval.classBody)->addMethod((yysemantic_stack_[(3) - (3)].func), true); }
    break;

  case 16:

/* Line 690 of lalr1.cc  */
#line 161 "parser.y"
    { (yyval.block) = (yysemantic_stack_[(3) - (2)].block); }
    break;

  case 17:

/* Line 690 of lalr1.cc  */
#line 165 "parser.y"
    { (yyval.block) = new BlockASTNode(); }
    break;

  case 18:

/* Line 690 of lalr1.cc  */
#line 166 "parser.y"
    { (yyval.block) = (yysemantic_stack_[(3) - (1)].block); (yyval.block)->append((yysemantic_stack_[(3) - (2)].decl)); }
    break;

  case 19:

/* Line 690 of lalr1.cc  */
#line 167 "parser.y"
    { (yyval.block) = (yysemantic_stack_[(3) - (1)].block); (yyval.block)->append((yysemantic_stack_[(3) - (2)].ast)); }
    break;

  case 20:

/* Line 690 of lalr1.cc  */
#line 168 "parser.y"
    { (yyval.block) = (yysemantic_stack_[(3) - (1)].block); (yyval.block)->append((yysemantic_stack_[(3) - (2)].ast)); }
    break;

  case 21:

/* Line 690 of lalr1.cc  */
#line 169 "parser.y"
    { (yyval.block) = (yysemantic_stack_[(3) - (1)].block); (yyval.block)->append((yysemantic_stack_[(3) - (2)].ret)); }
    break;

  case 22:

/* Line 690 of lalr1.cc  */
#line 170 "parser.y"
    { (yyval.block) = (yysemantic_stack_[(2) - (1)].block); (yyval.block)->append((yysemantic_stack_[(2) - (2)].for_node)); }
    break;

  case 23:

/* Line 690 of lalr1.cc  */
#line 171 "parser.y"
    { (yyval.block) = (yysemantic_stack_[(2) - (1)].block); (yyval.block)->append((yysemantic_stack_[(2) - (2)].if_node)); }
    break;

  case 24:

/* Line 690 of lalr1.cc  */
#line 172 "parser.y"
    { (yyval.block) = (yysemantic_stack_[(2) - (1)].block); (yyval.block)->append((yysemantic_stack_[(2) - (2)].while_node)); }
    break;

  case 25:

/* Line 690 of lalr1.cc  */
#line 177 "parser.y"
    { (yyval.for_node) = new ForASTNode((yysemantic_stack_[(9) - (3)].nodes), (yysemantic_stack_[(9) - (5)].ast), (yysemantic_stack_[(9) - (7)].nodes), (yysemantic_stack_[(9) - (9)].block)); }
    break;

  case 26:

/* Line 690 of lalr1.cc  */
#line 182 "parser.y"
    { (yyval.if_node) = new IfASTNode((yysemantic_stack_[(7) - (3)].ast), (yysemantic_stack_[(7) - (5)].block), (yysemantic_stack_[(7) - (7)].block)); }
    break;

  case 27:

/* Line 690 of lalr1.cc  */
#line 184 "parser.y"
    { (yyval.if_node) = new IfASTNode((yysemantic_stack_[(5) - (3)].ast), (yysemantic_stack_[(5) - (5)].block)); }
    break;

  case 28:

/* Line 690 of lalr1.cc  */
#line 189 "parser.y"
    { (yyval.while_node) = new WhileASTNode((yysemantic_stack_[(5) - (3)].ast), (yysemantic_stack_[(5) - (5)].block)); }
    break;

  case 29:

/* Line 690 of lalr1.cc  */
#line 194 "parser.y"
    { (yyval.decl) = new VariableDeclASTNode(*(yysemantic_stack_[(6) - (1)].sval), *(yysemantic_stack_[(6) - (3)].sval), (yysemantic_stack_[(6) - (5)].ival)); }
    break;

  case 30:

/* Line 690 of lalr1.cc  */
#line 196 "parser.y"
    { (yyval.decl) = new VariableDeclASTNode(*(yysemantic_stack_[(3) - (1)].sval), *(yysemantic_stack_[(3) - (3)].sval)); }
    break;

  case 31:

/* Line 690 of lalr1.cc  */
#line 198 "parser.y"
    { (yyval.decl) = new ConstructorASTNode(*(yysemantic_stack_[(6) - (1)].sval), *(yysemantic_stack_[(6) - (3)].sval), (yysemantic_stack_[(6) - (5)].nodes)); }
    break;

  case 32:

/* Line 690 of lalr1.cc  */
#line 202 "parser.y"
    { (yyval.ast) = new VariableDeleteASTNode(*(yysemantic_stack_[(2) - (2)].sval)); }
    break;

  case 33:

/* Line 690 of lalr1.cc  */
#line 206 "parser.y"
    { (yyval.ast) = new UnaryOpASTNode("!", (yysemantic_stack_[(2) - (2)].ast)); }
    break;

  case 34:

/* Line 690 of lalr1.cc  */
#line 208 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("<", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 35:

/* Line 690 of lalr1.cc  */
#line 210 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("<=", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 36:

/* Line 690 of lalr1.cc  */
#line 212 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode(">", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 37:

/* Line 690 of lalr1.cc  */
#line 214 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode(">=", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 38:

/* Line 690 of lalr1.cc  */
#line 216 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("==", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 39:

/* Line 690 of lalr1.cc  */
#line 218 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("!=", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 40:

/* Line 690 of lalr1.cc  */
#line 220 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("+", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 41:

/* Line 690 of lalr1.cc  */
#line 222 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("-", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 42:

/* Line 690 of lalr1.cc  */
#line 224 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("*", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 43:

/* Line 690 of lalr1.cc  */
#line 226 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("/", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 44:

/* Line 690 of lalr1.cc  */
#line 228 "parser.y"
    { (yyval.ast) = new AssignmentASTNode("=", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 45:

/* Line 690 of lalr1.cc  */
#line 230 "parser.y"
    { (yyval.ast) = new IntNumberASTNode((yysemantic_stack_[(1) - (1)].ival)); }
    break;

  case 46:

/* Line 690 of lalr1.cc  */
#line 232 "parser.y"
    { (yyval.ast) = new DoubleNumberASTNode((yysemantic_stack_[(1) - (1)].dval)); }
    break;

  case 47:

/* Line 690 of lalr1.cc  */
#line 234 "parser.y"
    { (yyval.ast) = (yysemantic_stack_[(3) - (2)].ast); }
    break;

  case 48:

/* Line 690 of lalr1.cc  */
#line 236 "parser.y"
    { (yyval.ast) = new MethodCallASTNode((yysemantic_stack_[(6) - (1)].var), *(yysemantic_stack_[(6) - (3)].sval), (yysemantic_stack_[(6) - (5)].nodes)); }
    break;

  case 49:

/* Line 690 of lalr1.cc  */
#line 238 "parser.y"
    { (yyval.ast) = (yysemantic_stack_[(1) - (1)].call); }
    break;

  case 50:

/* Line 690 of lalr1.cc  */
#line 240 "parser.y"
    { (yyval.ast) = (yysemantic_stack_[(1) - (1)].var); }
    break;

  case 51:

/* Line 690 of lalr1.cc  */
#line 244 "parser.y"
    { (yyval.ret) = new ReturnASTNode((yysemantic_stack_[(2) - (2)].ast)); }
    break;

  case 52:

/* Line 690 of lalr1.cc  */
#line 249 "parser.y"
    { (yyval.var) = new ArraySubscriptingASTNode((yysemantic_stack_[(4) - (1)].var), (yysemantic_stack_[(4) - (3)].ast)); }
    break;

  case 53:

/* Line 690 of lalr1.cc  */
#line 251 "parser.y"
    { (yyval.var) = new FieldASTNode((yysemantic_stack_[(3) - (1)].var), *(yysemantic_stack_[(3) - (3)].sval)) ; }
    break;

  case 54:

/* Line 690 of lalr1.cc  */
#line 253 "parser.y"
    { (yyval.var) = new VariableASTNode(*(yysemantic_stack_[(1) - (1)].sval)); }
    break;

  case 55:

/* Line 690 of lalr1.cc  */
#line 257 "parser.y"
    { (yyval.call) = new FuncCallASTNode(*(yysemantic_stack_[(4) - (1)].sval), (yysemantic_stack_[(4) - (3)].nodes)); }
    break;

  case 56:

/* Line 690 of lalr1.cc  */
#line 262 "parser.y"
    { (yyval.nodes) = new ASTNodeContainer(); }
    break;

  case 57:

/* Line 690 of lalr1.cc  */
#line 264 "parser.y"
    { (yyval.nodes) = new ASTNodeContainer(); (yyval.nodes)->append((yysemantic_stack_[(1) - (1)].ast)); }
    break;

  case 58:

/* Line 690 of lalr1.cc  */
#line 266 "parser.y"
    { (yyval.nodes) = (yysemantic_stack_[(3) - (1)].nodes); (yyval.nodes)->append((yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 59:

/* Line 690 of lalr1.cc  */
#line 271 "parser.y"
    { (yyval.func) = new FuncDefASTNode(*(yysemantic_stack_[(5) - (1)].sval), *(yysemantic_stack_[(5) - (5)].sval)); }
    break;

  case 60:

/* Line 690 of lalr1.cc  */
#line 273 "parser.y"
    { (yyval.func) = new FuncDefASTNode(*(yysemantic_stack_[(8) - (1)].sval), *(yysemantic_stack_[(8) - (5)].sval), true); }
    break;

  case 61:

/* Line 690 of lalr1.cc  */
#line 275 "parser.y"
    { (yyval.func) = new FuncDefASTNode(*(yysemantic_stack_[(6) - (1)].sval), *(yysemantic_stack_[(6) - (6)].sval), false, (yysemantic_stack_[(6) - (3)].params)); }
    break;

  case 62:

/* Line 690 of lalr1.cc  */
#line 277 "parser.y"
    { (yyval.func) = new FuncDefASTNode(*(yysemantic_stack_[(9) - (1)].sval), *(yysemantic_stack_[(9) - (6)].sval), true, (yysemantic_stack_[(9) - (3)].params)); }
    break;

  case 63:

/* Line 690 of lalr1.cc  */
#line 282 "parser.y"
    { (yyval.params) = new ArgumentsContainer(); (yyval.params)->append((yysemantic_stack_[(1) - (1)].arg)); }
    break;

  case 64:

/* Line 690 of lalr1.cc  */
#line 284 "parser.y"
    { (yyval.params) = (yysemantic_stack_[(3) - (1)].params); (yyval.params)->append((yysemantic_stack_[(3) - (3)].arg)); }
    break;

  case 65:

/* Line 690 of lalr1.cc  */
#line 289 "parser.y"
    { (yyval.arg) = new ArgumentASTNode(*(yysemantic_stack_[(6) - (1)].sval), *(yysemantic_stack_[(6) - (3)].sval), (yysemantic_stack_[(6) - (5)].ival)); }
    break;

  case 66:

/* Line 690 of lalr1.cc  */
#line 291 "parser.y"
    { (yyval.arg) = new ArgumentASTNode(*(yysemantic_stack_[(3) - (1)].sval), *(yysemantic_stack_[(3) - (3)].sval)); }
    break;

  case 67:

/* Line 690 of lalr1.cc  */
#line 295 "parser.y"
    { (yyval.func) = (yysemantic_stack_[(3) - (2)].func); (yyval.func)->addBody((yysemantic_stack_[(3) - (3)].block)); }
    break;

  case 68:

/* Line 690 of lalr1.cc  */
#line 296 "parser.y"
    { (yyval.func) = (yysemantic_stack_[(3) - (2)].func); (yyval.func)->makeExtern(); }
    break;

  case 69:

/* Line 690 of lalr1.cc  */
#line 301 "parser.y"
    { (yyval.constrDef) = new ConstructorDefASTNode(*(yysemantic_stack_[(5) - (2)].sval), (yysemantic_stack_[(5) - (5)].block)); }
    break;

  case 70:

/* Line 690 of lalr1.cc  */
#line 303 "parser.y"
    { (yyval.constrDef) = new ConstructorDefASTNode(*(yysemantic_stack_[(6) - (2)].sval), (yysemantic_stack_[(6) - (6)].block), (yysemantic_stack_[(6) - (4)].params)); }
    break;



/* Line 690 of lalr1.cc  */
#line 929 "parser.cpp"
	default:
          break;
      }
    /* User semantic actions sometimes alter yychar, and that requires
       that yytoken be updated with the new translation.  We take the
       approach of translating immediately before every use of yytoken.
       One alternative is translating here after every semantic action,
       but that translation would be missed if the semantic action
       invokes YYABORT, YYACCEPT, or YYERROR immediately after altering
       yychar.  In the case of YYABORT or YYACCEPT, an incorrect
       destructor might then be invoked immediately.  In the case of
       YYERROR, subsequent parser actions might lead to an incorrect
       destructor call or verbose syntax error message before the
       lookahead is translated.  */
    YY_SYMBOL_PRINT ("-> $$ =", yyr1_[yyn], &yyval, &yyloc);

    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();

    yysemantic_stack_.push (yyval);
    yylocation_stack_.push (yyloc);

    /* Shift the result of the reduction.  */
    yyn = yyr1_[yyn];
    yystate = yypgoto_[yyn - yyntokens_] + yystate_stack_[0];
    if (0 <= yystate && yystate <= yylast_
	&& yycheck_[yystate] == yystate_stack_[0])
      yystate = yytable_[yystate];
    else
      yystate = yydefgoto_[yyn - yyntokens_];
    goto yynewstate;

  /*------------------------------------.
  | yyerrlab -- here on detecting error |
  `------------------------------------*/
  yyerrlab:
    /* Make sure we have latest lookahead translation.  See comments at
       user semantic actions for why this is necessary.  */
    yytoken = yytranslate_ (yychar);

    /* If not already recovering from an error, report this error.  */
    if (!yyerrstatus_)
      {
	++yynerrs_;
	if (yychar == yyempty_)
	  yytoken = yyempty_;
	error (yylloc, yysyntax_error_ (yystate, yytoken));
      }

    yyerror_range[1] = yylloc;
    if (yyerrstatus_ == 3)
      {
	/* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

	if (yychar <= yyeof_)
	  {
	  /* Return failure if at end of input.  */
	  if (yychar == yyeof_)
	    YYABORT;
	  }
	else
	  {
	    yydestruct_ ("Error: discarding", yytoken, &yylval, &yylloc);
	    yychar = yyempty_;
	  }
      }

    /* Else will try to reuse lookahead token after shifting the error
       token.  */
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;

    yyerror_range[1] = yylocation_stack_[yylen - 1];
    /* Do not reclaim the symbols of the rule which action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    yystate = yystate_stack_[0];
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

    for (;;)
      {
	yyn = yypact_[yystate];
	if (!yy_pact_value_is_default_ (yyn))
	{
	  yyn += yyterror_;
	  if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
	    {
	      yyn = yytable_[yyn];
	      if (0 < yyn)
		break;
	    }
	}

	/* Pop the current state because it cannot handle the error token.  */
	if (yystate_stack_.height () == 1)
	YYABORT;

	yyerror_range[1] = yylocation_stack_[0];
	yydestruct_ ("Error: popping",
		     yystos_[yystate],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);
	yypop_ ();
	yystate = yystate_stack_[0];
	YY_STACK_PRINT ();
      }

    yyerror_range[2] = yylloc;
    // Using YYLLOC is tempting, but would change the location of
    // the lookahead.  YYLOC is available though.
    YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yyloc);

    /* Shift the error token.  */
    YY_SYMBOL_PRINT ("Shifting", yystos_[yyn],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);

    yystate = yyn;
    goto yynewstate;

    /* Accept.  */
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    /* Abort.  */
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (yychar != yyempty_)
      {
        /* Make sure we have latest lookahead translation.  See comments
           at user semantic actions for why this is necessary.  */
        yytoken = yytranslate_ (yychar);
        yydestruct_ ("Cleanup: discarding lookahead", yytoken, &yylval,
                     &yylloc);
      }

    /* Do not reclaim the symbols of the rule which action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (yystate_stack_.height () != 1)
      {
	yydestruct_ ("Cleanup: popping",
		   yystos_[yystate_stack_[0]],
		   &yysemantic_stack_[0],
		   &yylocation_stack_[0]);
	yypop_ ();
      }

    return yyresult;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (int yystate, int yytoken)
  {
    std::string yyres;
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yytoken) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yychar.
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (yytoken != yyempty_)
      {
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            /* Stay within bounds of both yycheck and yytname.  */
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = 0;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
  const signed char Parser::yypact_ninf_ = -119;
  const short int
  Parser::yypact_[] =
  {
      -119,    32,   130,  -119,     1,    14,    14,  -119,  -119,    24,
      53,    71,    54,    59,    73,     5,  -119,  -119,  -119,  -119,
      76,  -119,    65,    80,    23,  -119,    55,    78,    46,    79,
      81,   100,    99,    -3,    -3,  -119,    -3,   101,   120,   132,
     139,    17,  -119,  -119,  -119,  -119,  -119,   141,   146,    97,
     148,    -9,  -119,  -119,  -119,   135,   -22,   140,   158,  -119,
    -119,   151,   153,   152,  -119,   175,  -119,   137,   188,  -119,
      -3,    -3,    -3,    -3,   161,  -119,  -119,    -3,    -3,    -3,
      -3,    -3,    -3,    -3,    -3,    -3,    -3,    -3,  -119,  -119,
     170,    -3,   194,  -119,  -119,   179,   180,   185,  -119,   154,
     171,   188,    57,    60,    28,   203,   203,   203,   203,   199,
     199,    27,    27,  -119,  -119,   188,   206,    11,    12,   186,
     187,   189,    71,    71,    -3,    -3,  -119,    -3,   190,    -3,
    -119,    58,    91,  -119,  -119,   191,  -119,   192,   188,   117,
      98,   195,   111,  -119,    62,  -119,    71,    -3,  -119,  -119,
    -119,  -119,  -119,   118,    71,  -119
  };

  /* YYDEFACT[S] -- default reduction number in state S.  Performed when
     YYTABLE doesn't specify something else to do.  Zero means the
     default is an error.  */
  const unsigned char
  Parser::yydefact_[] =
  {
         3,     0,     2,     1,     0,     0,     0,     4,     5,     7,
       0,     0,     0,     0,     0,     0,    17,    67,    68,     9,
       8,    11,     0,     0,     0,    63,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,     0,     0,     0,     0,
       0,    54,    46,    45,    22,    23,    24,     0,     0,     0,
       0,    50,    49,    10,     6,     0,     0,     0,     0,    14,
      13,    59,    66,     0,    64,    54,    33,     0,    51,    32,
       0,     0,    56,    56,     0,    18,    19,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    20,    21,
       0,     0,     0,    15,    12,     0,     0,    61,    47,     0,
       0,    57,     0,     0,    30,    34,    35,    37,    36,    38,
      39,    40,    41,    42,    43,    44,    53,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    55,    56,     0,    56,
      52,     0,     0,    60,    65,     0,    28,    27,    58,     0,
       0,     0,     0,    69,     0,    62,     0,    56,    31,    29,
      48,    70,    26,     0,     0,    25
  };

  /* YYPGOTO[NTERM-NUM].  */
  const short int
  Parser::yypgoto_[] =
  {
      -119,  -119,  -119,  -119,  -119,  -119,  -119,  -118,  -119,  -119,
    -119,  -119,   196,  -119,   -26,  -119,  -119,  -119,   -61,   219,
     113,   197,   -27,  -119
  };

  /* YYDEFGOTO[NTERM-NUM].  */
  const signed char
  Parser::yydefgoto_[] =
  {
        -1,     1,     2,     7,    14,    20,    28,    17,    26,    44,
      45,    46,    47,    48,   101,    50,    51,    52,   102,    11,
      24,    25,     8,    60
  };

  /* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule which
     number is the opposite.  If YYTABLE_NINF_, syntax error.  */
  const signed char Parser::yytable_ninf_ = -1;
  const unsigned char
  Parser::yytable_[] =
  {
        49,    59,     5,     6,   136,   137,    33,    66,    67,    90,
      68,    34,   103,   143,    77,    78,    79,    80,    81,    82,
      22,    83,    84,    85,    86,    91,   151,   131,   152,    93,
      87,    73,     3,    65,    42,    43,   155,     9,    31,    85,
      86,    23,   127,    32,    99,   100,   130,    13,    23,    74,
      10,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   128,    54,    33,   117,   140,    15,   142,    34,
      55,     6,    35,    56,    16,   126,    18,   124,    16,   125,
     124,    36,    57,    37,    38,    39,   153,    16,    40,    21,
      29,    41,    42,    43,    63,    19,    27,    29,   138,   139,
      77,    78,    79,    80,    81,    82,   144,    83,    84,    85,
      86,    32,    30,   148,    53,    61,    87,    62,   124,    88,
      77,    78,    79,    80,    81,    82,   150,    83,    84,    85,
      86,   124,    63,   154,    70,    23,    87,    69,   124,   147,
      77,    78,    79,    80,    81,    82,    71,    83,    84,    85,
      86,     4,    98,    72,     5,     6,    87,    77,    78,    79,
      80,    81,    82,    75,    83,    84,    85,    86,    76,   122,
      89,    92,    74,    87,    77,    78,    79,    80,    81,    82,
      94,    83,    84,    85,    86,    95,   123,    96,    97,    73,
      87,    77,    78,    79,    80,    81,    82,   104,    83,    84,
      85,    86,    77,    78,    79,    80,   116,    87,   118,    83,
      84,    85,    86,    83,    84,    85,    86,   119,   120,   121,
     129,   133,   134,   146,    58,    12,   145,   135,   141,    64,
     149,   132
  };

  /* YYCHECK.  */
  const unsigned char
  Parser::yycheck_[] =
  {
        26,    28,    24,    25,   122,   123,     9,    33,    34,    18,
      36,    14,    73,   131,     3,     4,     5,     6,     7,     8,
      15,    10,    11,    12,    13,    34,   144,    15,   146,    56,
      19,    14,     0,    36,    37,    38,   154,    36,    15,    12,
      13,    36,    14,    20,    70,    71,    35,    23,    36,    32,
      36,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    34,    17,     9,    91,   127,    14,   129,    14,
      24,    25,    17,    27,    16,    15,    22,    20,    16,    22,
      20,    26,    36,    28,    29,    30,   147,    16,    33,    16,
      32,    36,    37,    38,    32,    36,    20,    32,   124,   125,
       3,     4,     5,     6,     7,     8,    15,    10,    11,    12,
      13,    20,    32,    15,    36,    36,    19,    36,    20,    22,
       3,     4,     5,     6,     7,     8,    15,    10,    11,    12,
      13,    20,    32,    15,    14,    36,    19,    36,    20,    22,
       3,     4,     5,     6,     7,     8,    14,    10,    11,    12,
      13,    21,    15,    14,    24,    25,    19,     3,     4,     5,
       6,     7,     8,    22,    10,    11,    12,    13,    22,    15,
      22,    36,    32,    19,     3,     4,     5,     6,     7,     8,
      22,    10,    11,    12,    13,    34,    15,    34,    36,    14,
      19,     3,     4,     5,     6,     7,     8,    36,    10,    11,
      12,    13,     3,     4,     5,     6,    36,    19,    14,    10,
      11,    12,    13,    10,    11,    12,    13,    38,    38,    34,
      14,    35,    35,    31,    28,     6,    35,    38,    38,    32,
      35,   118
  };

  /* STOS_[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
  const unsigned char
  Parser::yystos_[] =
  {
         0,    40,    41,     0,    21,    24,    25,    42,    61,    36,
      36,    58,    58,    23,    43,    14,    16,    46,    22,    36,
      44,    16,    15,    36,    59,    60,    47,    20,    45,    32,
      32,    15,    20,     9,    14,    17,    26,    28,    29,    30,
      33,    36,    37,    38,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    36,    17,    24,    27,    36,    51,    61,
      62,    36,    36,    32,    60,    36,    53,    53,    53,    36,
      14,    14,    14,    14,    32,    22,    22,     3,     4,     5,
       6,     7,     8,    10,    11,    12,    13,    19,    22,    22,
      18,    34,    36,    61,    22,    34,    34,    36,    15,    53,
      53,    53,    57,    57,    36,    53,    53,    53,    53,    53,
      53,    53,    53,    53,    53,    53,    36,    53,    14,    38,
      38,    34,    15,    15,    20,    22,    15,    14,    34,    14,
      35,    15,    59,    35,    35,    38,    46,    46,    53,    53,
      57,    38,    57,    46,    15,    35,    31,    22,    15,    35,
      15,    46,    46,    57,    15,    46
  };

#if YYDEBUG
  /* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
     to YYLEX-NUM.  */
  const unsigned short int
  Parser::yytoken_number_[] =
  {
         0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293
  };
#endif

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
  const unsigned char
  Parser::yyr1_[] =
  {
         0,    39,    40,    41,    41,    41,    42,    43,    43,    44,
      44,    45,    45,    45,    45,    45,    46,    47,    47,    47,
      47,    47,    47,    47,    47,    48,    49,    49,    50,    51,
      51,    51,    52,    53,    53,    53,    53,    53,    53,    53,
      53,    53,    53,    53,    53,    53,    53,    53,    53,    53,
      53,    54,    55,    55,    55,    56,    57,    57,    57,    58,
      58,    58,    58,    59,    59,    60,    60,    61,    61,    62,
      62
  };

  /* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
  const unsigned char
  Parser::yyr2_[] =
  {
         0,     2,     1,     0,     2,     2,     6,     0,     2,     1,
       3,     0,     3,     2,     2,     3,     3,     0,     3,     3,
       3,     3,     2,     2,     2,     9,     7,     5,     5,     6,
       3,     6,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     1,     1,     3,     6,     1,
       1,     2,     4,     3,     1,     4,     0,     1,     3,     5,
       8,     6,     9,     1,     3,     6,     3,     3,     3,     5,
       6
  };

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
  /* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
     First, the terminals, then, starting at \a yyntokens_, nonterminals.  */
  const char*
  const Parser::yytname_[] =
  {
    "\"end of file\"", "error", "$undefined", "LT", "LE", "GE", "GT", "EQ",
  "NE", "NOT", "PLUS", "MINUS", "TIMES", "SLASH", "LPAREN", "RPAREN",
  "BLOCK_BEGINS", "BLOCK_ENDS", "ARROW", "ASSIGN", "COMMA", "CLASS",
  "SEMICOLON", "COLON", "DEF", "EXTERN", "RETURN", "VIRT", "DELETE",
  "WHILE", "IF", "ELSE", "OF", "FOR", "LBRACKET", "RBRACKET",
  "\"identifier\"", "\"double number\"", "\"int number\"", "$accept",
  "program", "unit", "class_definition", "parents", "parents_",
  "class_body", "code_block", "statements", "for_statement",
  "if_statement", "while_statement", "var_decl", "var_delete", "expr",
  "return", "variable", "func_call", "expressions", "func_prototype",
  "prototype_params", "param", "func_definition", "constructor_def", 0
  };
#endif

#if YYDEBUG
  /* YYRHS -- A `-1'-separated list of the rules' RHS.  */
  const Parser::rhs_number_type
  Parser::yyrhs_[] =
  {
        40,     0,    -1,    41,    -1,    -1,    41,    42,    -1,    41,
      61,    -1,    21,    36,    43,    16,    45,    17,    -1,    -1,
      23,    44,    -1,    36,    -1,    44,    20,    36,    -1,    -1,
      45,    51,    22,    -1,    45,    62,    -1,    45,    61,    -1,
      45,    27,    61,    -1,    16,    47,    17,    -1,    -1,    47,
      51,    22,    -1,    47,    52,    22,    -1,    47,    53,    22,
      -1,    47,    54,    22,    -1,    47,    48,    -1,    47,    49,
      -1,    47,    50,    -1,    33,    14,    57,    22,    53,    22,
      57,    15,    46,    -1,    30,    14,    53,    15,    46,    31,
      46,    -1,    30,    14,    53,    15,    46,    -1,    29,    14,
      53,    15,    46,    -1,    36,    32,    36,    34,    38,    35,
      -1,    36,    32,    36,    -1,    36,    32,    36,    14,    57,
      15,    -1,    28,    36,    -1,     9,    53,    -1,    53,     3,
      53,    -1,    53,     4,    53,    -1,    53,     6,    53,    -1,
      53,     5,    53,    -1,    53,     7,    53,    -1,    53,     8,
      53,    -1,    53,    10,    53,    -1,    53,    11,    53,    -1,
      53,    12,    53,    -1,    53,    13,    53,    -1,    53,    19,
      53,    -1,    38,    -1,    37,    -1,    14,    53,    15,    -1,
      55,    18,    36,    14,    57,    15,    -1,    56,    -1,    55,
      -1,    26,    53,    -1,    55,    34,    53,    35,    -1,    55,
      18,    36,    -1,    36,    -1,    36,    14,    57,    15,    -1,
      -1,    53,    -1,    57,    20,    53,    -1,    36,    14,    15,
      32,    36,    -1,    36,    14,    15,    32,    36,    34,    38,
      35,    -1,    36,    14,    59,    15,    32,    36,    -1,    36,
      14,    59,    15,    32,    36,    34,    38,    35,    -1,    60,
      -1,    59,    20,    60,    -1,    36,    32,    36,    34,    38,
      35,    -1,    36,    32,    36,    -1,    24,    58,    46,    -1,
      25,    58,    22,    -1,    24,    36,    14,    15,    46,    -1,
      24,    36,    14,    59,    15,    46,    -1
  };

  /* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
     YYRHS.  */
  const unsigned short int
  Parser::yyprhs_[] =
  {
         0,     0,     3,     5,     6,     9,    12,    19,    20,    23,
      25,    29,    30,    34,    37,    40,    44,    48,    49,    53,
      57,    61,    65,    68,    71,    74,    84,    92,    98,   104,
     111,   115,   122,   125,   128,   132,   136,   140,   144,   148,
     152,   156,   160,   164,   168,   172,   174,   176,   180,   187,
     189,   191,   194,   199,   203,   205,   210,   211,   213,   217,
     223,   232,   239,   249,   251,   255,   262,   266,   270,   274,
     280
  };

  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
  const unsigned short int
  Parser::yyrline_[] =
  {
         0,   121,   121,   125,   126,   127,   131,   136,   137,   141,
     143,   149,   150,   152,   154,   156,   161,   165,   166,   167,
     168,   169,   170,   171,   172,   176,   181,   183,   188,   193,
     195,   197,   202,   205,   207,   209,   211,   213,   215,   217,
     219,   221,   223,   225,   227,   229,   231,   233,   235,   237,
     239,   244,   248,   250,   252,   257,   262,   263,   265,   270,
     272,   274,   276,   281,   283,   288,   290,   295,   296,   300,
     302
  };

  // Print the state stack on the debug stream.
  void
  Parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (state_stack_type::const_iterator i = yystate_stack_.begin ();
	 i != yystate_stack_.end (); ++i)
      *yycdebug_ << ' ' << *i;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  Parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    /* Print the symbols being reduced, and their result.  */
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
	       << " (line " << yylno << "):" << std::endl;
    /* The symbols being reduced.  */
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
		       yyrhs_[yyprhs_[yyrule] + yyi],
		       &(yysemantic_stack_[(yynrhs) - (yyi + 1)]),
		       &(yylocation_stack_[(yynrhs) - (yyi + 1)]));
  }
#endif // YYDEBUG

  /* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
  Parser::token_number_type
  Parser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
           0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38
    };
    if ((unsigned int) t <= yyuser_token_number_max_)
      return translate_table[t];
    else
      return yyundef_token_;
  }

  const int Parser::yyeof_ = 0;
  const int Parser::yylast_ = 231;
  const int Parser::yynnts_ = 24;
  const int Parser::yyempty_ = -2;
  const int Parser::yyfinal_ = 3;
  const int Parser::yyterror_ = 1;
  const int Parser::yyerrcode_ = 256;
  const int Parser::yyntokens_ = 39;

  const unsigned int Parser::yyuser_token_number_max_ = 293;
  const Parser::token_number_type Parser::yyundef_token_ = 2;


} // yy

/* Line 1136 of lalr1.cc  */
#line 1569 "parser.cpp"


/* Line 1138 of lalr1.cc  */
#line 306 "parser.y"


void yy::Parser::error(const yy::location& l, const std::string& m)
{
    driver.error(m);
}

