/* A Bison parser, made by GNU Bison 2.5.  */

/* Skeleton implementation for Bison LALR(1) parsers in C++
   
      Copyright (C) 2002-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */


/* First part of user declarations.  */


/* Line 293 of lalr1.cc  */
#line 39 "parser.tab.c"


#include "parser.tab.h"

/* User implementation prologue.  */


/* Line 299 of lalr1.cc  */
#line 48 "parser.tab.c"
/* Unqualified %code blocks.  */

/* Line 300 of lalr1.cc  */
#line 36 "parser.y"

#include "driver.hpp"



/* Line 300 of lalr1.cc  */
#line 59 "parser.tab.c"

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                               \
 do                                                                    \
   if (N)                                                              \
     {                                                                 \
       (Current).begin = YYRHSLOC (Rhs, 1).begin;                      \
       (Current).end   = YYRHSLOC (Rhs, N).end;                        \
     }                                                                 \
   else                                                                \
     {                                                                 \
       (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;        \
     }                                                                 \
 while (false)
#endif

/* Suppress unused-variable warnings by "using" E.  */
#define YYUSE(e) ((void) (e))

/* Enable debugging if requested.  */
#if YYDEBUG

/* A pseudo ostream that takes yydebug_ into account.  */
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)	\
do {							\
  if (yydebug_)						\
    {							\
      *yycdebug_ << Title << ' ';			\
      yy_symbol_print_ ((Type), (Value), (Location));	\
      *yycdebug_ << std::endl;				\
    }							\
} while (false)

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug_)				\
    yy_reduce_print_ (Rule);		\
} while (false)

# define YY_STACK_PRINT()		\
do {					\
  if (yydebug_)				\
    yystack_print_ ();			\
} while (false)

#else /* !YYDEBUG */

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_REDUCE_PRINT(Rule)
# define YY_STACK_PRINT()

#endif /* !YYDEBUG */

#define yyerrok		(yyerrstatus_ = 0)
#define yyclearin	(yychar = yyempty_)

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)


namespace yy {

/* Line 382 of lalr1.cc  */
#line 145 "parser.tab.c"

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              /* Fall through.  */
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  Parser::Parser (Driver& driver_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver (driver_yyarg)
  {
  }

  Parser::~Parser ()
  {
  }

#if YYDEBUG
  /*--------------------------------.
  | Print this symbol on YYOUTPUT.  |
  `--------------------------------*/

  inline void
  Parser::yy_symbol_value_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yyvaluep);
    switch (yytype)
      {
         default:
	  break;
      }
  }


  void
  Parser::yy_symbol_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    *yycdebug_ << (yytype < yyntokens_ ? "token" : "nterm")
	       << ' ' << yytname_[yytype] << " ("
	       << *yylocationp << ": ";
    yy_symbol_value_print_ (yytype, yyvaluep, yylocationp);
    *yycdebug_ << ')';
  }
#endif

  void
  Parser::yydestruct_ (const char* yymsg,
			   int yytype, semantic_type* yyvaluep, location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yymsg);
    YYUSE (yyvaluep);

    YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

    switch (yytype)
      {
  
	default:
	  break;
      }
  }

  void
  Parser::yypop_ (unsigned int n)
  {
    yystate_stack_.pop (n);
    yysemantic_stack_.pop (n);
    yylocation_stack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif

  inline bool
  Parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  Parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::parse ()
  {
    /// Lookahead and lookahead in internal form.
    int yychar = yyempty_;
    int yytoken = 0;

    /* State.  */
    int yyn;
    int yylen = 0;
    int yystate = 0;

    /* Error handling.  */
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// Semantic value of the lookahead.
    semantic_type yylval;
    /// Location of the lookahead.
    location_type yylloc;
    /// The locations where the error started and ended.
    location_type yyerror_range[3];

    /// $$.
    semantic_type yyval;
    /// @$.
    location_type yyloc;

    int yyresult;

    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stacks.  The initial state will be pushed in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystate_stack_ = state_stack_type (0);
    yysemantic_stack_ = semantic_stack_type (0);
    yylocation_stack_ = location_stack_type (0);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* New state.  */
  yynewstate:
    yystate_stack_.push (yystate);
    YYCDEBUG << "Entering state " << yystate << std::endl;

    /* Accept?  */
    if (yystate == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    /* Backup.  */
  yybackup:

    /* Try to take a decision without lookahead.  */
    yyn = yypact_[yystate];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    /* Read a lookahead token.  */
    if (yychar == yyempty_)
      {
	YYCDEBUG << "Reading a token: ";
	yychar = yylex (&yylval, driver);
      }


    /* Convert token to internal form.  */
    if (yychar <= yyeof_)
      {
	yychar = yytoken = yyeof_;
	YYCDEBUG << "Now at end of input." << std::endl;
      }
    else
      {
	yytoken = yytranslate_ (yychar);
	YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
      }

    /* If the proper action on seeing token YYTOKEN is to reduce or to
       detect an error, take that action.  */
    yyn += yytoken;
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yytoken)
      goto yydefault;

    /* Reduce or error.  */
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
	if (yy_table_value_is_error_ (yyn))
	  goto yyerrlab;
	yyn = -yyn;
	goto yyreduce;
      }

    /* Shift the lookahead token.  */
    YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

    /* Discard the token being shifted.  */
    yychar = yyempty_;

    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* Count tokens shifted since error; after three, turn off error
       status.  */
    if (yyerrstatus_)
      --yyerrstatus_;

    yystate = yyn;
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystate];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    /* If YYLEN is nonzero, implement the default value of the action:
       `$$ = $1'.  Otherwise, use the top of the stack.

       Otherwise, the following line sets YYVAL to garbage.
       This behavior is undocumented and Bison
       users should not rely upon it.  */
    if (yylen)
      yyval = yysemantic_stack_[yylen - 1];
    else
      yyval = yysemantic_stack_[0];

    {
      slice<location_type, location_stack_type> slice (yylocation_stack_, yylen);
      YYLLOC_DEFAULT (yyloc, slice, yylen);
    }
    YY_REDUCE_PRINT (yyn);
    switch (yyn)
      {
	  case 2:

/* Line 690 of lalr1.cc  */
#line 88 "parser.y"
    { (yyval.unit) = (yysemantic_stack_[(1) - (1)].unit); driver.result = (yyval.unit); driver.result->codegen(); }
    break;

  case 3:

/* Line 690 of lalr1.cc  */
#line 92 "parser.y"
    { (yyval.unit) = new UnitASTNode(); }
    break;

  case 4:

/* Line 690 of lalr1.cc  */
#line 93 "parser.y"
    { (yyval.unit) = (yysemantic_stack_[(2) - (1)].unit); (yyval.unit)->append((yysemantic_stack_[(2) - (2)].func)); }
    break;

  case 5:

/* Line 690 of lalr1.cc  */
#line 97 "parser.y"
    { (yyval.block) = (yysemantic_stack_[(3) - (2)].block); }
    break;

  case 6:

/* Line 690 of lalr1.cc  */
#line 101 "parser.y"
    { (yyval.block) = new BlockASTNode(); }
    break;

  case 7:

/* Line 690 of lalr1.cc  */
#line 102 "parser.y"
    { (yyval.block) = (yysemantic_stack_[(3) - (1)].block); (yyval.block)->append((yysemantic_stack_[(3) - (2)].ast)); }
    break;

  case 8:

/* Line 690 of lalr1.cc  */
#line 103 "parser.y"
    { (yyval.block) = (yysemantic_stack_[(3) - (1)].block); (yyval.block)->append((yysemantic_stack_[(3) - (2)].ret)); }
    break;

  case 9:

/* Line 690 of lalr1.cc  */
#line 104 "parser.y"
    { (yyval.block) = (yysemantic_stack_[(2) - (1)].block); (yyval.block)->append((yysemantic_stack_[(2) - (2)].for_node)); }
    break;

  case 10:

/* Line 690 of lalr1.cc  */
#line 105 "parser.y"
    { (yyval.block) = (yysemantic_stack_[(2) - (1)].block); (yyval.block)->append((yysemantic_stack_[(2) - (2)].if_node)); }
    break;

  case 11:

/* Line 690 of lalr1.cc  */
#line 106 "parser.y"
    { (yyval.block) = (yysemantic_stack_[(2) - (1)].block); (yyval.block)->append((yysemantic_stack_[(2) - (2)].while_node)); }
    break;

  case 12:

/* Line 690 of lalr1.cc  */
#line 111 "parser.y"
    { (yyval.for_node) = new ForASTNode((yysemantic_stack_[(9) - (3)].exprs), (yysemantic_stack_[(9) - (5)].exprs), (yysemantic_stack_[(9) - (7)].exprs), (yysemantic_stack_[(9) - (9)].block)); }
    break;

  case 13:

/* Line 690 of lalr1.cc  */
#line 116 "parser.y"
    { (yyval.if_node) = new IfASTNode((yysemantic_stack_[(7) - (3)].ast), (yysemantic_stack_[(7) - (5)].block), (yysemantic_stack_[(7) - (7)].block)); }
    break;

  case 14:

/* Line 690 of lalr1.cc  */
#line 118 "parser.y"
    { (yyval.if_node) = new IfASTNode((yysemantic_stack_[(5) - (3)].ast), (yysemantic_stack_[(5) - (5)].block)); }
    break;

  case 15:

/* Line 690 of lalr1.cc  */
#line 123 "parser.y"
    { (yyval.while_node) = new WhileASTNode((yysemantic_stack_[(5) - (3)].ast), (yysemantic_stack_[(5) - (5)].block)); }
    break;

  case 16:

/* Line 690 of lalr1.cc  */
#line 133 "parser.y"
    { (yyval.ast) = new UnaryOpASTNode("!", (yysemantic_stack_[(2) - (2)].ast)); }
    break;

  case 17:

/* Line 690 of lalr1.cc  */
#line 134 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("<", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 18:

/* Line 690 of lalr1.cc  */
#line 135 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("<=", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 19:

/* Line 690 of lalr1.cc  */
#line 136 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode(">", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 20:

/* Line 690 of lalr1.cc  */
#line 137 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode(">=", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 21:

/* Line 690 of lalr1.cc  */
#line 138 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("==", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 22:

/* Line 690 of lalr1.cc  */
#line 139 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("!=", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 23:

/* Line 690 of lalr1.cc  */
#line 140 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("+", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 24:

/* Line 690 of lalr1.cc  */
#line 141 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("-", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 25:

/* Line 690 of lalr1.cc  */
#line 142 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("*", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 26:

/* Line 690 of lalr1.cc  */
#line 143 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("/", (yysemantic_stack_[(3) - (1)].ast), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 27:

/* Line 690 of lalr1.cc  */
#line 144 "parser.y"
    { (yyval.ast) = (yysemantic_stack_[(3) - (2)].ast); }
    break;

  case 28:

/* Line 690 of lalr1.cc  */
#line 145 "parser.y"
    { (yyval.ast) = new NumberASTNode((yysemantic_stack_[(1) - (1)].dval)); }
    break;

  case 29:

/* Line 690 of lalr1.cc  */
#line 146 "parser.y"
    { (yyval.ast) = (yysemantic_stack_[(1) - (1)].var); }
    break;

  case 30:

/* Line 690 of lalr1.cc  */
#line 147 "parser.y"
    { (yyval.ast) = (yysemantic_stack_[(1) - (1)].call); }
    break;

  case 31:

/* Line 690 of lalr1.cc  */
#line 148 "parser.y"
    { (yyval.ast) = (yysemantic_stack_[(1) - (1)].ast); }
    break;

  case 32:

/* Line 690 of lalr1.cc  */
#line 152 "parser.y"
    { (yyval.ast) = new BinaryOpASTNode("=", new VariableASTNode(*(yysemantic_stack_[(3) - (1)].sval)), (yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 33:

/* Line 690 of lalr1.cc  */
#line 156 "parser.y"
    { (yyval.ret) = new ReturnASTNode((yysemantic_stack_[(2) - (2)].ast)); }
    break;

  case 34:

/* Line 690 of lalr1.cc  */
#line 160 "parser.y"
    { (yyval.var) = new VariableASTNode(*(yysemantic_stack_[(1) - (1)].sval)); }
    break;

  case 35:

/* Line 690 of lalr1.cc  */
#line 164 "parser.y"
    { (yyval.call) = new FuncCallASTNode(*(yysemantic_stack_[(3) - (1)].sval), new BlockASTNode()); }
    break;

  case 36:

/* Line 690 of lalr1.cc  */
#line 165 "parser.y"
    { (yyval.call) = new FuncCallASTNode(*(yysemantic_stack_[(4) - (1)].sval), (yysemantic_stack_[(4) - (3)].exprs)); }
    break;

  case 37:

/* Line 690 of lalr1.cc  */
#line 169 "parser.y"
    { (yyval.exprs) = new nodes_t(); (yyval.exprs)->push_back((yysemantic_stack_[(1) - (1)].ast)); }
    break;

  case 38:

/* Line 690 of lalr1.cc  */
#line 170 "parser.y"
    { (yyval.exprs) = (yysemantic_stack_[(3) - (1)].exprs); (yyval.exprs)->push_back((yysemantic_stack_[(3) - (3)].ast)); }
    break;

  case 39:

/* Line 690 of lalr1.cc  */
#line 174 "parser.y"
    { (yyval.func) = new FuncDefASTNode(*(yysemantic_stack_[(3) - (1)].sval), new BlockASTNode()); }
    break;

  case 40:

/* Line 690 of lalr1.cc  */
#line 175 "parser.y"
    { (yyval.func) = new FuncDefASTNode(*(yysemantic_stack_[(4) - (1)].sval), (yysemantic_stack_[(4) - (3)].params)); }
    break;

  case 41:

/* Line 690 of lalr1.cc  */
#line 180 "parser.y"
    { (yyval.params) = new params_t(); (yyval.params)->push_back((yysemantic_stack_[(1) - (1)].var)); }
    break;

  case 42:

/* Line 690 of lalr1.cc  */
#line 181 "parser.y"
    { (yyval.params) = (yysemantic_stack_[(3) - (1)].params); (yyval.params)->push_back((yysemantic_stack_[(3) - (3)].var)); }
    break;

  case 43:

/* Line 690 of lalr1.cc  */
#line 185 "parser.y"
    { (yyval.func) = (yysemantic_stack_[(3) - (2)].func); (yyval.func)->addBody((yysemantic_stack_[(3) - (3)].block)); }
    break;

  case 44:

/* Line 690 of lalr1.cc  */
#line 186 "parser.y"
    { (yyval.func) = (yysemantic_stack_[(3) - (2)].func); (yyval.func)->makeExtern(); }
    break;



/* Line 690 of lalr1.cc  */
#line 747 "parser.tab.c"
	default:
          break;
      }
    /* User semantic actions sometimes alter yychar, and that requires
       that yytoken be updated with the new translation.  We take the
       approach of translating immediately before every use of yytoken.
       One alternative is translating here after every semantic action,
       but that translation would be missed if the semantic action
       invokes YYABORT, YYACCEPT, or YYERROR immediately after altering
       yychar.  In the case of YYABORT or YYACCEPT, an incorrect
       destructor might then be invoked immediately.  In the case of
       YYERROR, subsequent parser actions might lead to an incorrect
       destructor call or verbose syntax error message before the
       lookahead is translated.  */
    YY_SYMBOL_PRINT ("-> $$ =", yyr1_[yyn], &yyval, &yyloc);

    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();

    yysemantic_stack_.push (yyval);
    yylocation_stack_.push (yyloc);

    /* Shift the result of the reduction.  */
    yyn = yyr1_[yyn];
    yystate = yypgoto_[yyn - yyntokens_] + yystate_stack_[0];
    if (0 <= yystate && yystate <= yylast_
	&& yycheck_[yystate] == yystate_stack_[0])
      yystate = yytable_[yystate];
    else
      yystate = yydefgoto_[yyn - yyntokens_];
    goto yynewstate;

  /*------------------------------------.
  | yyerrlab -- here on detecting error |
  `------------------------------------*/
  yyerrlab:
    /* Make sure we have latest lookahead translation.  See comments at
       user semantic actions for why this is necessary.  */
    yytoken = yytranslate_ (yychar);

    /* If not already recovering from an error, report this error.  */
    if (!yyerrstatus_)
      {
	++yynerrs_;
	if (yychar == yyempty_)
	  yytoken = yyempty_;
	error (yylloc, yysyntax_error_ (yystate, yytoken));
      }

    yyerror_range[1] = yylloc;
    if (yyerrstatus_ == 3)
      {
	/* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

	if (yychar <= yyeof_)
	  {
	  /* Return failure if at end of input.  */
	  if (yychar == yyeof_)
	    YYABORT;
	  }
	else
	  {
	    yydestruct_ ("Error: discarding", yytoken, &yylval, &yylloc);
	    yychar = yyempty_;
	  }
      }

    /* Else will try to reuse lookahead token after shifting the error
       token.  */
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;

    yyerror_range[1] = yylocation_stack_[yylen - 1];
    /* Do not reclaim the symbols of the rule which action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    yystate = yystate_stack_[0];
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

    for (;;)
      {
	yyn = yypact_[yystate];
	if (!yy_pact_value_is_default_ (yyn))
	{
	  yyn += yyterror_;
	  if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
	    {
	      yyn = yytable_[yyn];
	      if (0 < yyn)
		break;
	    }
	}

	/* Pop the current state because it cannot handle the error token.  */
	if (yystate_stack_.height () == 1)
	YYABORT;

	yyerror_range[1] = yylocation_stack_[0];
	yydestruct_ ("Error: popping",
		     yystos_[yystate],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);
	yypop_ ();
	yystate = yystate_stack_[0];
	YY_STACK_PRINT ();
      }

    yyerror_range[2] = yylloc;
    // Using YYLLOC is tempting, but would change the location of
    // the lookahead.  YYLOC is available though.
    YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yyloc);

    /* Shift the error token.  */
    YY_SYMBOL_PRINT ("Shifting", yystos_[yyn],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);

    yystate = yyn;
    goto yynewstate;

    /* Accept.  */
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    /* Abort.  */
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (yychar != yyempty_)
      {
        /* Make sure we have latest lookahead translation.  See comments
           at user semantic actions for why this is necessary.  */
        yytoken = yytranslate_ (yychar);
        yydestruct_ ("Cleanup: discarding lookahead", yytoken, &yylval,
                     &yylloc);
      }

    /* Do not reclaim the symbols of the rule which action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (yystate_stack_.height () != 1)
      {
	yydestruct_ ("Cleanup: popping",
		   yystos_[yystate_stack_[0]],
		   &yysemantic_stack_[0],
		   &yylocation_stack_[0]);
	yypop_ ();
      }

    return yyresult;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (int yystate, int yytoken)
  {
    std::string yyres;
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yytoken) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yychar.
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (yytoken != yyempty_)
      {
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            /* Stay within bounds of both yycheck and yytname.  */
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = 0;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
  const signed char Parser::yypact_ninf_ = -64;
  const short int
  Parser::yypact_[] =
  {
       -64,     9,   120,   -64,    13,    13,   -64,     5,    39,    37,
      -2,   -64,   -64,   -64,   -64,   -64,   -64,    27,    -7,   -64,
      42,    34,    34,   -64,    34,    80,    93,   106,    -6,   -64,
     -64,   -64,   -64,    61,   -64,    66,   -64,   -64,   -64,   111,
      72,   111,    34,    34,    34,    30,    34,    34,    34,    34,
      34,    34,    34,    34,    34,    34,    34,   -64,   -64,   -64,
      85,    98,   111,   124,   -64,    41,   111,   132,   132,   138,
     138,   -64,   -64,   122,   122,    46,    46,    39,    39,    34,
      34,   -64,   -64,    73,   111,   128,    39,    34,   -64,   117,
      39,   -64
  };

  /* YYDEFACT[S] -- default reduction number in state S.  Performed when
     YYTABLE doesn't specify something else to do.  Zero means the
     default is an error.  */
  const unsigned char
  Parser::yydefact_[] =
  {
         3,     0,     2,     1,     0,     0,     4,     0,     0,     0,
       0,     6,    43,    44,    39,    34,    41,     0,     0,    40,
       0,     0,     0,     5,     0,     0,     0,     0,    34,    28,
       9,    10,    11,     0,    31,     0,    29,    30,    42,    16,
       0,    33,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     7,     8,    27,
       0,     0,    37,     0,    35,     0,    32,    17,    18,    20,
      19,    21,    22,    23,    24,    25,    26,     0,     0,     0,
       0,    36,    15,    14,    38,     0,     0,     0,    13,     0,
       0,    12
  };

  /* YYPGOTO[NTERM-NUM].  */
  const signed char
  Parser::yypgoto_[] =
  {
       -64,   -64,   -64,   -63,   -64,   -64,   -64,   -64,   -18,   -64,
     -64,    -9,   -64,   -40,   107,   -64,   -64
  };

  /* YYDEFGOTO[NTERM-NUM].  */
  const signed char
  Parser::yydefgoto_[] =
  {
        -1,     1,     2,    12,    18,    30,    31,    32,    62,    34,
      35,    36,    37,    63,     8,    17,     6
  };

  /* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule which
     number is the opposite.  If YYTABLE_NINF_, syntax error.  */
  const signed char Parser::yytable_ninf_ = -1;
  const unsigned char
  Parser::yytable_[] =
  {
        33,    16,    21,    39,    40,    65,    41,    22,    45,     3,
      23,    38,    46,    14,    82,    83,    24,    25,    26,    10,
      27,    28,    29,    88,    60,    61,    15,    91,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    21,
      85,     7,    19,    21,    22,    64,    20,    89,    22,    47,
      48,    49,    50,    51,    52,    11,    81,    13,    28,    29,
      79,    84,    28,    29,    47,    48,    49,    50,    51,    52,
      15,    53,    54,    55,    56,    47,    48,    49,    50,    51,
      52,    57,    53,    54,    55,    56,    58,    59,    47,    48,
      49,    50,    51,    52,    42,    53,    54,    55,    56,    86,
      77,    47,    48,    49,    50,    51,    52,    43,    53,    54,
      55,    56,     9,    78,    47,    48,    49,    50,    51,    52,
      44,    53,    54,    55,    56,    47,    48,    49,    50,    51,
      52,     0,    90,     0,    55,    56,    79,    49,    50,    51,
      52,     4,     5,    79,    80,    51,    52,    79,    87
  };

  /* YYCHECK.  */
  const signed char
  Parser::yycheck_[] =
  {
        18,    10,     9,    21,    22,    45,    24,    14,    14,     0,
      17,    20,    18,    15,    77,    78,    23,    24,    25,    14,
      27,    28,    29,    86,    42,    43,    28,    90,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,     9,
      80,    28,    15,     9,    14,    15,    19,    87,    14,     3,
       4,     5,     6,     7,     8,    16,    15,    20,    28,    29,
      19,    79,    28,    29,     3,     4,     5,     6,     7,     8,
      28,    10,    11,    12,    13,     3,     4,     5,     6,     7,
       8,    20,    10,    11,    12,    13,    20,    15,     3,     4,
       5,     6,     7,     8,    14,    10,    11,    12,    13,    26,
      15,     3,     4,     5,     6,     7,     8,    14,    10,    11,
      12,    13,     5,    15,     3,     4,     5,     6,     7,     8,
      14,    10,    11,    12,    13,     3,     4,     5,     6,     7,
       8,    -1,    15,    -1,    12,    13,    19,     5,     6,     7,
       8,    21,    22,    19,    20,     7,     8,    19,    20
  };

  /* STOS_[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
  const unsigned char
  Parser::yystos_[] =
  {
         0,    31,    32,     0,    21,    22,    46,    28,    44,    44,
      14,    16,    33,    20,    15,    28,    41,    45,    34,    15,
      19,     9,    14,    17,    23,    24,    25,    27,    28,    29,
      35,    36,    37,    38,    39,    40,    41,    42,    41,    38,
      38,    38,    14,    14,    14,    14,    18,     3,     4,     5,
       6,     7,     8,    10,    11,    12,    13,    20,    20,    15,
      38,    38,    38,    43,    15,    43,    38,    38,    38,    38,
      38,    38,    38,    38,    38,    38,    38,    15,    15,    19,
      20,    15,    33,    33,    38,    43,    26,    20,    33,    43,
      15,    33
  };

#if YYDEBUG
  /* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
     to YYLEX-NUM.  */
  const unsigned short int
  Parser::yytoken_number_[] =
  {
         0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284
  };
#endif

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
  const unsigned char
  Parser::yyr1_[] =
  {
         0,    30,    31,    32,    32,    33,    34,    34,    34,    34,
      34,    34,    35,    36,    36,    37,    38,    38,    38,    38,
      38,    38,    38,    38,    38,    38,    38,    38,    38,    38,
      38,    38,    39,    40,    41,    42,    42,    43,    43,    44,
      44,    45,    45,    46,    46
  };

  /* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
  const unsigned char
  Parser::yyr2_[] =
  {
         0,     2,     1,     0,     2,     3,     0,     3,     3,     2,
       2,     2,     9,     7,     5,     5,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     3,     2,     1,     3,     4,     1,     3,     3,
       4,     1,     3,     3,     3
  };

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
  /* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
     First, the terminals, then, starting at \a yyntokens_, nonterminals.  */
  const char*
  const Parser::yytname_[] =
  {
    "\"end of file\"", "error", "$undefined", "LT", "LE", "GE", "GT", "EQ",
  "NE", "NOT", "PLUS", "MINUS", "TIMES", "SLASH", "LPAREN", "RPAREN",
  "BLOCK_BEGINS", "BLOCK_ENDS", "ASSIGN", "COMMA", "SEMICOLON", "DEF",
  "EXTERN", "RETURN", "WHILE", "IF", "ELSE", "FOR", "\"identifier\"",
  "\"number\"", "$accept", "program", "unit", "code_block", "statements",
  "for_statement", "if_statement", "while_statement", "expr", "assignment",
  "return", "variable", "func_call", "expressions", "func_prototype",
  "prototype_params", "func_definition", 0
  };
#endif

#if YYDEBUG
  /* YYRHS -- A `-1'-separated list of the rules' RHS.  */
  const Parser::rhs_number_type
  Parser::yyrhs_[] =
  {
        31,     0,    -1,    32,    -1,    -1,    32,    46,    -1,    16,
      34,    17,    -1,    -1,    34,    38,    20,    -1,    34,    40,
      20,    -1,    34,    35,    -1,    34,    36,    -1,    34,    37,
      -1,    27,    14,    43,    20,    43,    20,    43,    15,    33,
      -1,    25,    14,    38,    15,    33,    26,    33,    -1,    25,
      14,    38,    15,    33,    -1,    24,    14,    38,    15,    33,
      -1,     9,    38,    -1,    38,     3,    38,    -1,    38,     4,
      38,    -1,    38,     6,    38,    -1,    38,     5,    38,    -1,
      38,     7,    38,    -1,    38,     8,    38,    -1,    38,    10,
      38,    -1,    38,    11,    38,    -1,    38,    12,    38,    -1,
      38,    13,    38,    -1,    14,    38,    15,    -1,    29,    -1,
      41,    -1,    42,    -1,    39,    -1,    28,    18,    38,    -1,
      23,    38,    -1,    28,    -1,    28,    14,    15,    -1,    28,
      14,    43,    15,    -1,    38,    -1,    43,    19,    38,    -1,
      28,    14,    15,    -1,    28,    14,    45,    15,    -1,    41,
      -1,    45,    19,    41,    -1,    21,    44,    33,    -1,    22,
      44,    20,    -1
  };

  /* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
     YYRHS.  */
  const unsigned char
  Parser::yyprhs_[] =
  {
         0,     0,     3,     5,     6,     9,    13,    14,    18,    22,
      25,    28,    31,    41,    49,    55,    61,    64,    68,    72,
      76,    80,    84,    88,    92,    96,   100,   104,   108,   110,
     112,   114,   116,   120,   123,   125,   129,   134,   136,   140,
     144,   149,   151,   155,   159
  };

  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
  const unsigned char
  Parser::yyrline_[] =
  {
         0,    88,    88,    92,    93,    97,   101,   102,   103,   104,
     105,   106,   110,   115,   117,   122,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   152,   156,   160,   164,   165,   169,   170,   174,
     175,   179,   181,   185,   186
  };

  // Print the state stack on the debug stream.
  void
  Parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (state_stack_type::const_iterator i = yystate_stack_.begin ();
	 i != yystate_stack_.end (); ++i)
      *yycdebug_ << ' ' << *i;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  Parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    /* Print the symbols being reduced, and their result.  */
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
	       << " (line " << yylno << "):" << std::endl;
    /* The symbols being reduced.  */
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
		       yyrhs_[yyprhs_[yyrule] + yyi],
		       &(yysemantic_stack_[(yynrhs) - (yyi + 1)]),
		       &(yylocation_stack_[(yynrhs) - (yyi + 1)]));
  }
#endif // YYDEBUG

  /* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
  Parser::token_number_type
  Parser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
           0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29
    };
    if ((unsigned int) t <= yyuser_token_number_max_)
      return translate_table[t];
    else
      return yyundef_token_;
  }

  const int Parser::yyeof_ = 0;
  const int Parser::yylast_ = 148;
  const int Parser::yynnts_ = 17;
  const int Parser::yyempty_ = -2;
  const int Parser::yyfinal_ = 3;
  const int Parser::yyterror_ = 1;
  const int Parser::yyerrcode_ = 256;
  const int Parser::yyntokens_ = 30;

  const unsigned int Parser::yyuser_token_number_max_ = 284;
  const Parser::token_number_type Parser::yyundef_token_ = 2;


} // yy

/* Line 1136 of lalr1.cc  */
#line 1320 "parser.tab.c"


/* Line 1138 of lalr1.cc  */
#line 188 "parser.y"


void yy::Parser::error(const yy::location& l, const std::string& m)
{
    driver.error(m);
}

